searchNodes=[{"doc":"Light-weight image processing module in Elixir with CImg. This module aims to create auxiliary routines for Deep Learning. Note: It still has a few image processing functions currentrly. Design detail The entity of the image handled by CImg is on the NIF side. On Elixir, the reference to the image generated by NIF is stored in the CImg structure. You cannot read out the pixels of the image and process it directly, instead you can use the image processing functions provided in this module. The image will be assigned to Erlang Resource by NIF, so the image will automatically be subject to garbage collection when it is no longer in use. This is most important point. Some of the functions in this module mutably rewrite the original image, when they recieve the image as %Builder{}. img = CImg.load(&quot;sample.jpg&quot;) # create %CImg{} CImg.builder(img) # duplicate img and create %Builder{} with it |&gt; CImg.fill(0) # rewrite |&gt; CImg.draw_circle(100, 100, 30, {0,0,255}) # rewrite |&gt; CImg.display(disp) Platform It has been confirmed to work in the following OS environment. Windows MSYS2/MinGW64 WSL2/Ubuntu 20.04 Data exchange with Nx It is easy to exchange CImg images and Nx tensors. # convert CImg image to Nx.Tensor iex&gt; img0 = CImg.load(&quot;sample.jpg&quot;) %CImg{{2448, 3264, 1, 3}, handle: #Reference&lt;0.2112145695.4205182979.233827&gt;} iex&gt; tensor = CImg.to_flat(img0, dtype: &quot;&lt;u8&quot;).data |&gt; Nx.from_binary({:u, 8}) # convert Nx.Tensor to CImg image iex&gt; img1 = Nx.to_binary(tensor) |&gt;CImg.create_from_bin(2448, 3264, 1, 3, &quot;&lt;u8&quot;) Demo There is a simple program in demo directory. You can do it by following the steps below. $ cd demo $ mix deps.get $ mix run -e &quot;CImgDemo.demo1&quot; Close the appaired window, and stop the demo program.","ref":"CImg.html","title":"CImg","type":"module"},{"doc":"Bluring image. Parameters img - %CImg{} or %Builder{} object sigma - boundary_conditions - is_gaussian - Examples img = CImg.load(&quot;sample.jpg&quot;) blured = CImg.blur(img, 0.3)","ref":"CImg.html#blur/4","title":"CImg.blur/4","type":"function"},{"doc":"See CImg.Builder.builder/1 .","ref":"CImg.html#builder/1","title":"CImg.builder/1","type":"function"},{"doc":"See CImg.Builder.builder/5 .","ref":"CImg.html#builder/5","title":"CImg.builder/5","type":"function"},{"doc":"Create image{x,y,z,c} filled val . Parameters x,y,z,c - image's x-size, y-size, z-size and spectrum. val - filling value. Examples img = CImg.create(200, 100, 1, 3, 127)","ref":"CImg.html#create/5","title":"CImg.create/5","type":"function"},{"doc":"Create image{x,y,z,c} from raw binary. create_from_bin helps you to make the image from the serialiezed output tensor of DNN model. Parameters bin - raw binary data to have in a image. x,y,z,c - image's x-size, y-size, z-size and spectrum. dtype - data type in the binary. any data types are converted to int8 in the image. &quot;&lt;f4&quot; - 32bit float (available value in range 0.0..1.0) &quot;&lt;u1&quot; - 8bit unsigned integer Examples bin = TflInterp.get_output_tensor(__MODULE__, 0) img = CImg.create_from_bin(bin, 300, 300, 1, 3, &quot;&lt;f4&quot;)","ref":"CImg.html#create_from_bin/6","title":"CImg.create_from_bin/6","type":"function"},{"doc":"Display the image on the CImgDisplay object. Parameters cimg - image object. display - CImgDisplay object Examples disp = CImgDisplay.create(img, &quot;Sample&quot;) CImg.display(imge, disp)","ref":"CImg.html#display/2","title":"CImg.display/2","type":"function"},{"doc":"[mut] Draw filled circle in the image. Parameters builder - builder object. x0,y0 - circle center location radius - circle radius color - filling color opacity - opacity: 0.0-1.0 Examples res = CImg.draw_circle(imge, 100, 80, 40, {0, 0, 255})","ref":"CImg.html#draw_circle/6","title":"CImg.draw_circle/6","type":"function"},{"doc":"[mut] Draw circle in the image. Parameters builder - builder object. x0,y0 - circle center location radius - circle radius color - boundary color opacity - opacity: 0.0-1.0 pattern - boundary line pattern Examples res = CImg.draw_circle(imge, 100, 80, 40, {0, 0, 255}, 0.3, 0xFFFFFFFF)","ref":"CImg.html#draw_circle/7","title":"CImg.draw_circle/7","type":"function"},{"doc":"[mut] Draw graph. Parameters cimg - image object %CImg{} to save.","ref":"CImg.html#draw_graph/9","title":"CImg.draw_graph/9","type":"function"},{"doc":"[mut] Draw rectangle in the image. Parameters builder - builder object. x0,y0,x1,y1 - diagonal coordinates. if all of them are integer, they mean actual coodinates. if all of them are float within 0.0-1.0, they mean ratio of the image. color - boundary color opacity - opacity: 0.0-1.0 pattern - boundary line pattern: 32bit pattern Examples CImg.draw_rect(img, 50, 30, 100, 80, {255, 0, 0}, 0.3, 0xFF00FF00) CImg.draw_rect(img, 0.2, 0.3, 0.6, 0.8, {0, 255, 0})","ref":"CImg.html#draw_rect/8","title":"CImg.draw_rect/8","type":"function"},{"doc":"Duplicate the image. Parameters cimg - image object %CImg{} to duplicate. Examples img = CImg . dup ( original ) # create new image object `img` have same shape and values of original.","ref":"CImg.html#dup/1","title":"CImg.dup/1","type":"function"},{"doc":"[mut] Filling the image with val . Parameters builder - builder object. val - filling value. Examples res = CImg.fill(img, 0x7f)","ref":"CImg.html#fill/2","title":"CImg.fill/2","type":"function"},{"doc":"Create the image from %Npy{} format data. Parameters npy - %Npy{} has 4 rank. Examples {:ok, npy} = Npy.load(&quot;image.npy&quot;) img = CImg.from_npy(npy)","ref":"CImg.html#from_npy/1","title":"CImg.from_npy/1","type":"function"},{"doc":"Get the pixel value at (x, y). Parameters cimg - image object. x,y,z,c - location in the image. Examples x = CImg.get(120, 40)","ref":"CImg.html#get/5","title":"CImg.get/5","type":"function"},{"doc":"Get crop. Parameters cimg - image object %CImg{} to save.","ref":"CImg.html#get_crop/10","title":"CImg.get_crop/10","type":"function"},{"doc":"","ref":"CImg.html#get_yuv/1","title":"CImg.get_yuv/1","type":"function"},{"doc":"Get the gray image of the image. Parameters cimg - image object %CImg{} to save. opt_pn - intensity inversion: 0 (default) - no-inversion, 1 - inversion Examples gray = CImg.gray(img, 1) # get inverted gray image","ref":"CImg.html#gray/2","title":"CImg.gray/2","type":"function"},{"doc":"Get the inverted image of the image. Examples inv = CImg.invert(img) # get inverted image","ref":"CImg.html#invert/1","title":"CImg.invert/1","type":"function"},{"doc":"Load a image from file. The file types supported by this function are jpeg, ping and bmp. The file extension identifies which file type it is. Parameters fname - file path of the image. Examples img = CImg.load(&quot;sample.jpg&quot;)","ref":"CImg.html#load/1","title":"CImg.load/1","type":"function"},{"doc":"Load a image from memory. You can create an image from loaded binary data of the image file. Parameters bin - loaded binary of the image file. Examples bin = File.read!(&quot;sample.jpg&quot;) img = CImg.load_from_memory(bin)","ref":"CImg.html#load_from_memory/1","title":"CImg.load_from_memory/1","type":"function"},{"doc":"Create color mapped image by lut. Parameters cimg - image object %CImg{} to save. lut - color mapping lut name - {&quot;default&quot;, &quot;lines&quot;, &quot;hot&quot;, &quot;cool&quot;, &quot;jet&quot;} boundary -","ref":"CImg.html#map/3","title":"CImg.map/3","type":"function"},{"doc":"mirroring the image on axis Parameters cimg - %CImg{} or %Builder{} object. axis - flipping axis: :x, :y Examples mirror = CImg.mirror(img, :y) # vertical flipping","ref":"CImg.html#mirror/2","title":"CImg.mirror/2","type":"function"},{"doc":"Get a new image object resized {x, y}. Parameters cimg - image object. {x, y} - resize width and height align - alignment mode :none - fit resizing :ul - fixed aspect resizing, upper-leftt alignment. :br - fixed aspect resizing, bottom-right alignment. fill - filling value for the margins, when fixed aspect resizing. Examples img = CImg.load(&quot;sample.jpg&quot;) res = CImg.get_resize(img, {300,300}, :ul)","ref":"CImg.html#resize/4","title":"CImg.resize/4","type":"function"},{"doc":"See CImg.Builder.runit/1 .","ref":"CImg.html#runit/1","title":"CImg.runit/1","type":"function"},{"doc":"Save the image to the file. Parameters cimg - image object to save. fname - file path for the image. (only jpeg images - xxx.jpg - are available now) Examples CImg.save(img, &quot;sample.jpg&quot;)","ref":"CImg.html#save/2","title":"CImg.save/2","type":"function"},{"doc":"[mut] Set the pixel value at (x, y). Parameters cimg - image object. val - value. x,y,z,c - location in the image. Examples res = CImg.set(0x7f, 120, 40)","ref":"CImg.html#set/6","title":"CImg.set/6","type":"function"},{"doc":"Get shape {x,y,z,c} of the image Parameters cimg - image object. Examples shape = CImg.shape(imge)","ref":"CImg.html#shape/1","title":"CImg.shape/1","type":"function"},{"doc":"Get byte size of the image Parameters builder - builder object. Examples size = CImg.sizh(imge)","ref":"CImg.html#size/1","title":"CImg.size/1","type":"function"},{"doc":"[mut] Thresholding the image. Parameters img - %CImg{} or %Builder{} object. val - threshold value soft - strict - Examples res = CImg.threshold(imge, 100)","ref":"CImg.html#threshold/4","title":"CImg.threshold/4","type":"function"},{"doc":"Get serialized binary of the image from top-left to bottom-right. to_flat/2 helps you to make 32bit-float arrary for the input tensors of DNN model. Parameters cimg - image object. opts - conversion options { :dtype, xx } - convert pixel value to data type. available: &quot;&lt;f4&quot;/32bit-float, &quot;&lt;u1&quot;/8bit-unsigned-char { :range, {lo, hi} } - normarilzed range when :dtype is &quot;&lt;f4&quot;. default range: {0.0, 1.0} :nchw - transform axes NHWC to NCHW. :bgr - convert color RGB -&gt; BGR. Examples img = CImg.load(&quot;sample.jpg&quot;) bin1 = CImg.to_flat(img, [{dtype: &quot;&lt;f4&quot;}, {:range, {-1.0, 1.0}}, :nchw]) # convert pixel value to 32bit-float in range -1.0..1.0 and transform axis to NCHW. bin2 = CImg.to_flat(img, dtype: &quot;&lt;f4&quot;) # convert pixel value to 32bit-float in range 0.0..1.0.","ref":"CImg.html#to_flat/2","title":"CImg.to_flat/2","type":"function"},{"doc":"Convert the image to JPEG binary. Parameters cimg - image object. Examples jpeg = CImg.load(&quot;sample.jpg&quot;) |&gt; CImg.resize({512, 512}) |&gt; CImg.to_jpeg() Kino.Image.new(jpeg, &quot;image/jpeg&quot;)","ref":"CImg.html#to_jpeg/1","title":"CImg.to_jpeg/1","type":"function"},{"doc":"Convert the image to %Npy{} format data. Parameters cimg - image object. Examples npy = CImg.load(&quot;sample.jpg&quot;) |&gt; CImg.to_npy()","ref":"CImg.html#to_npy/1","title":"CImg.to_npy/1","type":"function"},{"doc":"Convert the image to PNG binary. Parameters cimg - image object. Examples png = CImg.load(&quot;sample.jpg&quot;) |&gt; CImg.to_png()","ref":"CImg.html#to_png/1","title":"CImg.to_png/1","type":"function"},{"doc":"Pick the pixels on the source image and write on the distination image according to the mapping table. Parameters cimg - distination image object. cimg_src - source image. mapping - mapping table. ex) [{[10,10],[10,20]}], move pixel at [10,10] to [10,20] cx, cy, cz - location of upper-left mapping table on both images. Examples map = [{[20,20],[25,25]}, {[20,21],[25,26]}] src = CImg.load(&quot;sample.jpg&quot;) dst = CImg.builder(src) |&gt; CImg.transfer(src, map) |&gt; CImg.runit()","ref":"CImg.html#transfer/6","title":"CImg.transfer/6","type":"function"},{"doc":"","ref":"CImg.html#transpose/1","title":"CImg.transpose/1","type":"function"},{"doc":"Build and excecute image processing sequence. under construction","ref":"CImg.Builder.html","title":"CImg.Builder","type":"module"},{"doc":"Building image processing sequence. It allows to execute mutable operation in this sequence. Parameters image - %CImg{} or %Builder{} object. if %CImg{} is passed, `builder' duplicates the image object and returns it wrapped with %Builder{}. ## Examples Elixir img = CImg.load(&quot;sample.jpg&quot;) res = CImg.builder(img) |&gt; CImg.draw_circle(100, 100, 30, {0, 255, 0}) # draw a circle on the duplicated img.","ref":"CImg.Builder.html#builder/1","title":"CImg.Builder.builder/1","type":"function"},{"doc":"Building image processing sequence. This one creates empty image object instead recieving a image. Parameters x, y, z, c - image shape. val - filling value Examples res = CImg.builder(100, 100, 1, 3, 0) # 0 filled color image {100, 100, 1, 3} |&gt; CImg.draw_circle(100, 100, 30, {0, 255, 0}) # draw a circle on the duplicated img.","ref":"CImg.Builder.html#builder/5","title":"CImg.Builder.builder/5","type":"function"},{"doc":"","ref":"CImg.Builder.html#resize/4","title":"CImg.Builder.resize/4","type":"function"},{"doc":"Return %CImg{} converted from %Builder{}. Of course, mutable operations cannot be applied to %CImg{}. Parameters builder - %Builder{} object. Examples cimg = CImg.builder(100, 100, 1, 3, 0) |&gt; CImg.draw_circle(100, 100, 30, {0, 255, 0}) # draw a circle on the duplicated img. |&gt; CImg.runit() # cimg is %CImg{} object with a circle drawn on it.","ref":"CImg.Builder.html#runit/1","title":"CImg.Builder.runit/1","type":"function"},{"doc":"Display the CImg objects on PC screen. This module also provides the functionality to handle mouse-event, key-board-event, window-close-event, timer-event etc. Note: You can only use these features in :dev or :test mode.","ref":"CImgDisplay.html","title":"CImgDisplay","type":"module"},{"doc":"See CImg.NIF.cimgdisplay_button/1 .","ref":"CImgDisplay.html#button/1","title":"CImgDisplay.button/1","type":"function"},{"doc":"Create display object. Parameters Examples iex&gt; img = CImg.load(&quot;sample.jpg&quot;) iex&gt; display = CImgDisplay(img, &quot;Sample image&quot;) iex&gt;","ref":"CImgDisplay.html#create/5","title":"CImgDisplay.create/5","type":"function"},{"doc":"See CImg.NIF.cimgdisplay_is_closed/1 .","ref":"CImgDisplay.html#is_closed/1","title":"CImgDisplay.is_closed/1","type":"function"},{"doc":"See CImg.NIF.cimgdisplay_mouse_y/1 .","ref":"CImgDisplay.html#mouse_y/1","title":"CImgDisplay.mouse_y/1","type":"function"},{"doc":"See CImg.NIF.cimgdisplay_wait/1 .","ref":"CImgDisplay.html#wait/1","title":"CImgDisplay.wait/1","type":"function"},{"doc":"See CImg.NIF.cimgdisplay_wait_time/2 .","ref":"CImgDisplay.html#wait/2","title":"CImgDisplay.wait/2","type":"function"}]